#include "client.h"

void client(char *path, char *message, opts *opts) {
  int error;
  error = client_init(path);
  if (error) {
    fprintf(stderr, "client init failed: %s\n", strerror(error));
    interrupt_set_exit_flag();
    return;
  }

  error = client_request(message);
  if (error) {
    fprintf(stderr, "request failed: %s\n", strerror(error));
    interrupt_set_exit_flag();
    return;
  }

  printf("%s\n", client_get_response());
}

void client_subcommand(opts opts, int argc, char *argv[]) {
  set_usage_context(usage_client);

  char *message = "";
  if (opts.help) {
    show_usage(false);
  }
  else if (opts.username) {
    fprintf(stderr, "client: invalid flag: “-u/--username” only applies to server subcommand\n\n");
    show_usage(true);
    interrupt_set_exit_flag();
  }
  else if (argc <= 1) {
    fprintf(stderr, "client: please provide a path\n\n");
    show_usage(true);
    interrupt_set_exit_flag();
  }
  else {
    if (argc > 2) {
      // message provided
      message = argv[2];
    }
    client(argv[1], message, &opts);
  }
}
